#!/usr/bin/perl
# -- lyrics retrieval script for xmms
# -- 01/2006 by camico A7 users D07 sourceforge D07 net

use LWP::Simple qw(get);
eval "use Encode qw(from_to)"; $ENCODE_LOADED = not $@;
my $lyrdir = shift;
DBG( "Artist: $artist\nTitle:  $title" );

# =============================================================================
my $DEBUG = 1;

# =============================================================================

my $sep = "__00__";
my $string = join( " ", @ARGV );
my @info = split / $sep /, $string;
my $artist = $info[0];
my $title = $info[1];
my $realtitle = $info[1];
my $lyrfile = $lyrdir.$artist." - ".$title.".lyrics.xml";
# -----------------------------------------------------------------------------
my $html = "";
DBG( "Artist: $artist\nTitle:  $title" );

# see if another title was selected manually
# ------------------------------
if( open INFO, "<$lyrdir/$artist - $title.info" ) {
    my $lastline = "";
    while( $line = <INFO> ) {
        chomp($line);
        if( $lastline eq "SONG" ) {
            $realtitle = $line;
            last;
        }
        $lastline = $line;
    } close INFO;
	DBG( "realtitle: $realtitle" );
}

# 1. generate url
# ------------------------------
$urlartist = $artist;
$urlartist =~ s/\/|-//g;
$urlartist =~ s/^the (.*)/$1-the/i;

$urltitle = $realtitle;
$urltitle =~ s/\/|-//g;

$url = lc $urlartist ."-". lc $urltitle;
$url =~ s/\?|,|\!|=|\+|\:|\&|\.$//g;
$url =~ s/ |\.|\(|\)|\[|\]|\'/-/g;
$url =~ s//ae/g;
$url =~ s//oe/g;
$url =~ s//ue/g;
$url =~ s//ss/g;
while( $url =~ /--/ ) { $url =~ s/--/-/g; }
while( $url =~ /-$/ ) { $url =~ s/-$//; }
while( $url =~ /^-/ ) { $url =~ s/^-//; }
$url = "http://www.lyricsdownload.com/".$url."-lyrics.html";

# $url2 = $url;
# $url2 =~ s/\'//g;
# $url3 = $url;
# $url3 =~ s/\'/-acute-/g;
# $url4 = $url;
# $url4 =~ s/and-//i;

# 2. retrieve url and parse contents
# ------------------------------
DBG( "trying with: $url" );
$html = get $url;
notfound("Server not reachable.", 0) if not $html;

if( $html =~ /(style21\">.*?)<\/p>/s ) {
	
    $lyrics = $1;
    $lyrics =~ s/(\n|\nSponsored Link: )<a.*?\/a>//gis; # remove links with contents
    $lyrics =~ s/<.*?>//gis;       # remove all tags
    $lyrics =~ s/\n?document.*?\);\n?//gis;       # remove JS
    $lyrics =~ s/style21.*//gi;
    $lyrics =~ s/&amp;acute;/\'/gi;
	$lyrics =~ s/&/&amp;/g;
	$lyrics =~ s/\n *(.*)/\n$1/g;
	
	# get rid of fucking double newlines
	@emptylines = ($lyrics =~ /\r\n\r\n/g);
	@lines = ($lyrics =~ /\r\n/g);
	if( @emptylines >= @lines/2-1 ) {
		$lyrics =~ s/\r\n\r\n/\n/g;
	}
	
    DBG( "Lyrics: $lyrics" );

} else {
    notfound("Not found.", 1);
}

# Success
# -----------------------------------------------------------------------------
if( substr( $lyrics, 0, 1 ) eq "\n" ) { $lyrics = substr( $lyrics, 1 ); }

$realtitle =~ s/\&/\&amp;/g;
open FILE, ">:utf8", $lyrfile;
print FILE <<STOP;
<?xml version="1.0" encoding="utf-8" ?>
    <lyrc><result>
    <name>$realtitle</name>
    <group>$artist</group>
    <lyric>$lyrics</lyric>
    </result></lyrc>
STOP
close FILE;
exit;

# -----------------------------------------------------------------------------
sub write_result_list {
    my $err = shift;
    my $searchOn = shift;
    my $i = 0;
    $err =~ s/\&/\&amp;/g;
    DBG( "artist's songs:" );

    open FILE, ">:utf8", $lyrfile;
    print FILE '<?xml version="1.0" encoding="utf-8" ?><lyrc><suggest>';
    foreach( @artist_songs ) {
		$group = $artist_names[$i++];
		$group =~ s/<.*>//g;
		$group =~ s/&/&amp;/g;	
        $name = $_;
        $name =~ s/&/&amp;/g;
		$name =~ s/<.*>//g;
        print FILE '<song><name>'.$name.'</name><group>'.$group.'</group></song>';
    }
    if( $err ) { print FILE '<message>'.$err.'</message>'; }
    if( $searchOn ) { print FILE '<searchOn />'; }
    print FILE '</suggest></lyrc>';
    close FILE;
    exit;
}

# -----------------------------------------------------------------------------
sub notfound {
    my $err = shift;
    my $searchOn = shift;
    DBG( "lyrics for \"$artist - $title\" not found :( ... [$err]" );
    write_result_list( $err, $searchOn );
    exit;
}
# -----------------------------------------------------------------------------
sub DBG {
    my $str = shift;
    if( $DEBUG ) {
	$str =~ s/\n/\n       /g;
	print "[Lyrc] $str\n";
    }
}
