#!/usr/bin/perl
# -- lyrics retrieval script for xmms
# -- 04/2004 by camico A7 users D07 sourceforge D07 net

use LWP::Simple qw(get);
eval "use Encode qw(from_to)"; $ENCODE_LOADED = not $@;
my $lyrdir = shift;
DBG( "Artist: $artist\nTitle:  $title" );

# =============================================================================
my $DEBUG = 1;

my $CACHE_DAYS = 30;
my $CACHE = "$lyrdir/sing365.com/";
# =============================================================================

my $sep = "__00__";
my $string = join( " ", @ARGV );
my @info = split / $sep /, $string;
my $artist = $info[0];
my $title = $info[1];
my $realtitle = $info[1];
my $lyrfile = $lyrdir.$artist." - ".$title.".lyrics.xml";
my $cachefile = $CACHE.(lc $artist).".links.html";
# -----------------------------------------------------------------------------
my $urlhead  = "http://seek.sing365.com:8080/";
my $urlhead2 = "http://www.sing365.com/";
my $html = "";
DBG( "Artist: $artist\nTitle:  $title" );
DBG( "install Perl module \"Encode\" to reduce character (mainly apostroph) errors..." )
    if not $ENCODE_LOADED;

# see if another title was selected manually
# ------------------------------
if( open INFO, "<$lyrdir/$artist - $title.info" ) {
    my $lastline = "";
    while( $line = <INFO> ) {
        chomp($line);
        if( $lastline eq "SONG" ) {
            $realtitle = $line;
            last;
        }
        $lastline = $line;
    } close INFO;
	DBG( "realtitle: $realtitle" );
}

# 0. look at cache
# ------------------------------
if( $CACHE && ( (-d $CACHE && -w $CACHE) || mkdir( $CACHE ) ) ) {
    if( -M $cachefile < $CACHE_DAYS ) {
	if( open CACHE, "<$cachefile" ) {
	    while( $line = <CACHE> ) {
		$html .= $line;
	    } close CACHE;
	    DBG( "using cached lyrics list (age = ".(sprintf("%.2f days", (-M $cachefile))).")" );
	    if( $html eq "NOTFOUND" ) { notfound( "Artist unknown.", 1 ); }
	}
    } else { DBG( "renewing cache for $artist (age = ".(-M $cachefile).")" ); }
}
if( not $html ) {
    # 1. artist search
    # ------------------------------
    $artist_url = $artist;
    $artist_url =~ s/\'/ /g;
#    $artist_url =~ s/ /+/g;
#   $url = $urlhead."search.php?searchstr=".$artist_url."&category=artist&x=0&y=0";
    $url = $urlhead."cgi-bin/search?searchstr=".$artist_url."&category=artist&x=0&y=0";
    $html = get $url;
    DBG($url);
    notfound("Server not reachable.", 1) if not $html;

#   @url      = ($html =~ /(click\.php\?id.*?)>/gs);
#   @linkname = ($html =~ /click.php.*?=1>(.*?)<\/font><\/a>/gis);
    $html =~ s/<B>|<\/B>|<small.*?\/small>//g;
    @url      = ($html =~ /(music\/lyric.*?)\"/gs);
    @linkname = ($html =~ /music\/lyric.*?\".*?<b>(.*?) Biography<\/b>/gs);
    $hits = @url;

    if( not $hits ) {
		write_cache( "NOTFOUND" );
		notfound("Artist unknown.", 1);
    }
    DBG( "artist hits: [".join(", ", @linkname)."]" );

    # take the first artist link
    $url = $urlhead2.$url[0];
    # and correct it if another one is a better match
    for( $i=0; $i<@linkname; $i++ ) {
		if( $linkname[$i] =~ /$artist/i ) {
			$url = $urlhead2.$url[$i];
			last;
		}
    }
    DBG( "artist link: $url ");

    # 2. all lyrics
    # ------------------------------
    $html = get $url;
    $html =~ /(music\/lyric.*?)\"?>Lyrics<\/a>/i;
    $url = $urlhead2.$1;
    DBG( "all lyrics:  $url");

    $html = get $url;
    write_cache( $html );
}

# 3. look for title
# ------------------------------
$matchtitle1 = $realtitle;
$matchtitle1 =~ s/\?|,|\!|=|\+|\:|\&|\.$//g;
$matchtitle1 =~ s/ |\.|\(|\)|\[|\]/-/g;
while( $matchtitle1 =~ /--/ ) { $matchtitle1 =~ s/--/-/g; }
while( $matchtitle1 =~ /-$/ ) { $matchtitle1 =~ s/-$//; }
while( $matchtitle1 =~ /^-/ ) { $matchtitle1 =~ s/^-//; }
$matchtitle2 = $matchtitle1;
$matchtitle2 =~ s/\'//g;
$matchtitle3 = $matchtitle1;
$matchtitle3 =~ s/\'/-acute-/g;
$matchtitle4 = $matchtitle1;
$matchtitle4 =~ s/and-//i;

DBG( "trying with: $matchtitle1" );
if( $html =~ /(music\/lyric\.nsf\/$matchtitle1-lyrics.*?)\"?>/i ||
    $html =~ /(music\/lyric\.nsf\/$matchtitle2-lyrics.*?)\"?>/i ||
    $html =~ /(music\/lyric\.nsf\/$matchtitle3-lyrics.*?)\"?>/i ||
    $html =~ /(music\/lyric\.nsf\/$matchtitle4-lyrics.*?)\"?>/i ) {
    $url = $urlhead2.$1;
    DBG( "lyrics link: $url ");

    $html = get $url;
	notfound("Server not reachable.", 0) if not $html;
		
#    $titlestart = substr( $realtitle, 0, 3 );
#    if( $html =~ /(<B>(?i)$titlestart.*?Lyrics<\/B>.*?)<hr/s ) {
    if( $html =~ /Lyrics<\/B>(.*?)<hr/s ) {
	$lyrics = $1;
	$lyrics =~ s/(\n|\nSponsored Link: )<a.*?\/a>//gis; # remove links with contents
	$lyrics =~ s/<.*?>//gis;       # remove all tags
	$lyrics =~ s/\n?document.*?\);\n?//gis;       # remove JS
	$lyrics =~ s/.*?Print the Lyrics\)//gs;
	$lyrics =~ s/.*?$realtitle Lyrics//gis;
	Encode::from_to( $lyrics, "utf8", "latin9" ) if $ENCODE_LOADED;
	$lyrics =~ s/\?(\w)/\'$1/g;    # replace unknown chars with '
	$lyrics =~ s/&amp;acute;/\'/gi;
	DBG( "Lyrics: $lyrics" );
    } elsif( $html =~ /sorry, i have no/i ) {
		notfound("They are missing", 1);
    } else {
		notfound("But they should have been :( ...please report this.", 0);
    }
} else {
    DBG( "lyrics link not there" );

    # take the actually found artist instead of assuming that everything's correct
    # ignore song links which are colored, because they don't contain lyrics.
    @artist_names = ( $html =~ /(.*?) Lyrics - <.*?music\/lyric\.nsf\/.*?-lyrics-.*?\">(?!<font color).*? Lyrics/ig );
    @artist_songs = ( $html =~ /music\/lyric\.nsf\/.*?-lyrics-.*?\">(?!<font color)(.*?) Lyrics/ig );
    write_result_list();
}

# Success
# -----------------------------------------------------------------------------
if( substr( $lyrics, 0, 1 ) eq "\n" ) { $lyrics = substr( $lyrics, 1 ); }
$realtitle =~ s/\&/\&amp;/g;
open FILE, ">:utf8", $lyrfile;
print FILE <<STOP;
<?xml version="1.0" encoding="utf-8" ?>
    <lyrc><result>
    <name>$realtitle</name>
    <group>$artist</group>
    <lyric>$lyrics</lyric>
    </result></lyrc>
STOP
close FILE;
exit;

# -----------------------------------------------------------------------------
sub write_result_list {
    my $err = shift;
    my $searchOn = shift;
    my $i = 0;
    $err =~ s/\&/\&amp;/g;
    DBG( "artist's songs:" );

    open FILE, ">:utf8", $lyrfile;
    print FILE '<?xml version="1.0" encoding="utf-8" ?><lyrc><suggest>';
    foreach( @artist_songs ) {
	$group = $artist_names[$i++];
	$group =~ s/<.*>//g;
	$group =~ s/&/&amp;/g;	
        $name = $_;
        $name =~ s/&/&amp;/g;
	$name =~ s/<.*>//g;
        print FILE '<song><name>'.$name.'</name><group>'.$group.'</group></song>';
    }
    if( $err ) { print FILE '<message>'.$err.'</message>'; }
    if( $searchOn ) { print FILE '<searchOn />'; }
    print FILE '</suggest></lyrc>';
    close FILE;
    exit;
}

# -----------------------------------------------------------------------------
sub notfound {
    my $err = shift;
    my $searchOn = shift;
    DBG( "lyrics for \"$artist - $title\" not found :( ... [$err]" );
    write_result_list( $err, $searchOn );
    exit;
}
# -----------------------------------------------------------------------------
# sub linebreak {
#     my $lyr = shift;
#     @lines = split /\n/, $lyr;
#     $lyr = "";
# 
#     foreach( @lines ) {
# 	if( length($_) > $BREAK ) {
# 	    $line = $_;
# 	    while( length( $line ) > $BREAK ) {
# 		$cut = rindex( $line, ".", $BREAK );
# 		$cut = rindex( $line, "?", $BREAK ) if $cut < 0;
# 		$cut = rindex( $line, "!", $BREAK ) if $cut < 0;
# 		$cut = rindex( $line, "\"", $BREAK ) if $cut < 0;
# 		$cut = rindex( $line, " ", $BREAK ) if $cut < 0;
# 		$cut = $BREAK if $cut < 0;
# 		$cut++;
# 		$attach = substr( $line, 0, $cut ) . "\n";
# #		$attach =~ s/^[ ]*//;
# 		$lyr .= $attach;
# 		$line = substr( $line, $cut );
# 	    }
# 	    $lyr .= $line . "\n";
# 	} else {
# 	    $lyr .= $_ . "\n";
# 	}
#     }
#     return $lyr;
# }
# -----------------------------------------------------------------------------
sub write_cache {
    my $html = shift;
    unlink $cachefile;

    if( open CACHE, ">$cachefile" ) {
	@lines = split /\n/, $html;
	foreach( @lines ) {
	    if( $_ =~ /music\/lyric\.nsf\/.*?-lyrics-.*?\">/i || $_ eq "NOTFOUND" ) {
		print CACHE $_;
	    }
	}
	close CACHE;
    } else {
	DBG( "Can't save list to \"$cachefile\"" );
    }

}
# -----------------------------------------------------------------------------
sub escape {
    $str = shift;
#    $str =~ s/ /\\\ /g;
    $str =~ s/'/\\'/g; 
    $str =~ s/\(/\\(/g;   
    $str =~ s/\)/\\)/g;
    $str =~ s/\&/\\&/g;    
    $str =~ s/\;/\\;/g;
    $str =~ s/\[/\\[/g;
    $str =~ s/\]/\\]/g;
    return $str;
}
# -----------------------------------------------------------------------------
sub DBG {
    my $str = shift;
    if( $DEBUG ) {
	$str =~ s/\n/\n       /g;
	print "[Lyrc] $str\n";
    }
}
